# NOTE: Derived from blib/lib/InfoSys/FreeDB/Response/Write/1.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package InfoSys::FreeDB::Response::Write::1;

#line 191 "blib/lib/InfoSys/FreeDB/Response/Write/1.pm (autosplit into blib/lib/auto/InfoSys/FreeDB/Response/Write/1/new_from_content_ref.al)"
sub new_from_content_ref {
    my $class = shift;
    my $content_ref = shift;

    # Convert $opt->{content_ref} to @content_ref
    my @content_ref = split(/[\n\r]+/, ${$content_ref} );

    # Parse first line
    my $line = shift(@content_ref);
    my ($code, $tail) = $line =~ /$CODE_RX/;
    defined ($code) ||
        throw Error::Simple ('ERROR: InfoSys::FreeDB::Response::Write::1::new_from_content_ref, first line of specified \'content_ref\' does not contain a code.');
    my %opt;
    if ($code == 320) {
        my @tail = split(/\s+/, $tail, 2);
        %opt = (
            categ => $tail[0],
            code => $code,
            discid => $tail[1],
            result => 'OK, input CDDB data',
        );
    }
    elsif ($code == 401) {
        %opt = (
            code => $code,
            error => 1,
            result => 'Permission denied',
        );
    }
    elsif ($code == 402) {
        %opt = (
            code => $code,
            error => 1,
            result => 'Server file system full/file access failed',
        );
    }
    elsif ($code == 409) {
        %opt = (
            code => $code,
            error => 1,
            result => 'No handshake',
        );
    }
    elsif ($code == 501) {
        %opt = (
            code => $code,
            error => 1,
            result => 'Entry rejected: ' . $tail,
        );
    }
    else {
        throw Error::Simple ("ERROR: InfoSys::FreeDB::Response::Write::1::new_from_content_ref, unknown code '$code' returned. Allowed codes are 320, 401, 402, 409 and 501.");
    }

    # Create a new object and return it
    return( $class->new( \%opt ) );
}

# end of InfoSys::FreeDB::Response::Write::1::new_from_content_ref
1;
